﻿using System;
using System.IO;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Forms;
using System.Diagnostics;
using VisTool;

namespace Simple {
    static class Program {
        static VisToolContext run;
        public static string [] args;
        public static bool error = true;
        [STAThread]

        static void Main(string[] args) {
            Program.args = args;
            try {
                Application.EnableVisualStyles();
                Application.SetCompatibleTextRenderingDefault(false);
                run = new VisToolContext();
                if (error) return;
                Application.Run(run);
                run.Dispose();
                //MessageBox.Show("End of run", "Simple", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            catch (System.Exception ex) {
                Debug.Print("Main Error" + ex.ToString());
                if (run != null) run.Dispose();
            }
            Debug.Print("ExitThread");
            Application.ExitThread(); // Stop execution. Also closes the application windows.
        }

        static void Dispose() { run.Dispose(); }
    }

    // -----------------------------------------------------------------------------
    class VisToolContext : ApplicationContext {
        public VisToolContext() { // Constructor
            FormTemplate frmTpl;
            int bundleID;
            Debug.Print("Start run");
            try {
                if (Program.args.Length == 0) {
                    MessageBox.Show("Need a parameter specifying the name of the map file", "uVis", MessageBoxButtons.OK);
                    return;
                }
                if ( !Program.args[0].TrimEnd().EndsWith("vism")) {
                    MessageBox.Show(Program.args[0] + " is not a vism file", "uVis", MessageBoxButtons.OK);
                    return;
                }
                if (VisTool.Parser.OpenMapFile(Program.args[0])) {
                    frmTpl = VisEngine.OpenForm(VisEngine.startUpForm, null, out bundleID);
                    Debug.Print("Form opened");
                    Program.error = false;
                }
            }
            catch (System.Exception ex) {
                Debug.Print("Run Error" + ex.ToString());
            }
        }
    }
}
