﻿using System.Collections.Generic;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;

namespace uVisStudio.VisPropertyBox
{
    public partial class Category : UserControl {
        private bool isExpanded;
        public string CategoryName { get; private set; }
        public List<PropertyGridLine> Properties { get; private set; }

        public bool IsExpanded {
            get { return isExpanded; }
            set {
                isExpanded = value;
                if (isExpanded) {
                    this.expandButton.Visibility = Visibility.Hidden;
                    this.hideButton.Visibility = Visibility.Visible;
                } else {
                    this.expandButton.Visibility = Visibility.Visible;
                    this.hideButton.Visibility = Visibility.Hidden;
                }
            }
        }

        public Category() {
            Properties = new List<PropertyGridLine>();
            this.InitializeComponent();
            this.IsExpanded = true;
            this.Background = ColorConstants.Normal();
            this.border.BorderBrush = ColorConstants.Normal();
            this.border.Background = ColorConstants.Normal();
            this.expandButton.Source = uVisStudio.Properties.Resources.treeview_expand.GetImage();
            this.hideButton.Source = uVisStudio.Properties.Resources.treeview_collapse.GetImage();
            this.expandButton.Stretch = Stretch.None;
            this.hideButton.Stretch = Stretch.None;
        }

        public Category(string categoryName)
            : this() {
            this.CategoryName = categoryName;
            this.groupNameLabel.Content = categoryName;
        }

        public void SetName(string name) {
            this.CategoryName = name;
            this.groupNameLabel.Content = name;
        }


        private void ExpandButtonClick(object sender, RoutedEventArgs e) {
            this.IsExpanded = !this.IsExpanded;
        }
    }
}